@echo off

:: Backup-Laufwerke. Wenn fr BD_1 und BD_2 dasselbe Laufwerk
:: angegeben ist, fragt das Skript nicht, auf welchen Laufwerken
:: Backups angelegt werden sollen.
set "BD_1=N"
set "BD_2=E"

:: Name des Backup-Ordners. Kein Laufwerk angeben! Format: Ordner, Ordner\Ordner u. s. w.
set "TPB=Thunderbird-Profil-Backups"

:: Pfad zum Thunderbird-Profil
set "TP=E:\Thunderbird-Profil"

:: Pfad zu Rar.exe
set "rar=C:\Program Files\WinRAR\Rar.exe"

:: ------------------------------------------

tasklist | find /i "Thunderbird.exe">NUL
if not errorlevel 1 (
echo A B B R U C H
echo.
echo Thunderbird-Profil kann nicht gesichert
echo werden, da Thunderbird gestartet ist.
echo.
echo Thunderbird bitte manuell beenden
echo und Batchskript erneut starten.
echo.
echo Drcke eine beliebige Taste.
pause>NUL
goto :eof
)

echo Mchtest du jetzt ein Backup anlegen?
echo.
if exist "%rar%" goto :next
echo (Batch-Skript kann WinRAR nicht finden.)
echo.
echo Taste [2] Kopieren
echo Taste [3] Abbrechen
echo.
choice /c 23 /n
if errorlevel 2 goto :eof
if errorlevel 1 set "copy=defined"&goto :next2

:next
echo Taste [1] Archivieren (RAR)
echo Taste [2] Kopieren
echo Taste [3] Abbrechen
echo.
choice /c 123 /n
if errorlevel 3 goto :eof
if errorlevel 2 set "copy=defined"

:next2

if "%BD_1%"=="%BD_2%" set "drive_1=%BD_1%"&goto :next3

echo.
echo Auf welchen Laufwerken sollen Backups angelegt werden?
echo.
echo Taste [1] Laufwerk %BD_1%
echo Taste [2] Laufwerk %BD_2%
echo Taste [3] Laufwerk %BD_1% und %BD_2%
echo Taste [4] Abbrechen
echo.
choice /c 1234 /n
if errorlevel 4 goto :eof
if errorlevel 3 set "drive_1=%BD_1%"&set "drive_2=%BD_2%"&goto :next3
if errorlevel 2 set "drive_1=%BD_2%"&goto :next3
if errorlevel 1 set "drive_1=%BD_1%"&goto :next3

:next3

:: Siehe Workshop 'Batch for Runaways - Part III - Datums- und Zeitvariablen im Batch':
:: https://www.administrator.de/wissen/workshop-batch-runaways-part-iii-datums-zeitvariablen-17083.html
if not exist Datum_und_Uhrzeit.vbs echo Wscript.Echo Year(Now)^&" "^&Month(Now)^&" "^&Day(Now)^&" "^&Hour(Now)^&" "^&Minute(Now)^&" "^&Second(Now) > Datum_und_Uhrzeit.vbs
for /f "tokens=1-6" %%a in ('cscript //nologo Datum_und_Uhrzeit.vbs') do (
for %%i in ("YY=%%a" "MM=%%b" "DD=%%c" "hh=%%d" "min=%%e" "ss=%%f") do set %%i
)
del Datum_und_Uhrzeit.vbs
set "dummy=%MM:~1%"&if not defined dummy set "MM=0%MM%"
set "dummy=%DD:~1%"&if not defined dummy set "DD=0%DD%"
set "dummy=%hh:~1%"&if not defined dummy set "hh=0%hh%"
set "dummy=%min:~1%"&if not defined dummy set "min=0%min%"
set "dummy=%ss:~1%"&if not defined dummy set "ss=0%ss%"

set "name=%YY%-%MM%-%DD% @ %hh%.%min%.%ss%"

if defined copy (
xcopy /E /H /I /K "%TP%" "%drive_1%:\%TPB%\%name%"
if defined drive_2 xcopy /E /H /I /K "%TP%" "%drive_2%:\%TPB%\%name%"
goto :end
)

if not exist %drive_1%:\%TPB%\ md %drive_1%:\%TPB%

"%rar%" a -m5 -rr7p -t "%drive_1%:\%TPB%\%name%.rar" "%TP%"
if defined drive_2 xcopy /H /K "%drive_1%:\%TPB%\%name%.rar" "%drive_2%:\%TPB%\"

:end

echo.
echo Drcke eine beliebige Taste.
pause>NUL